Only whitespace changes to fix indentation.
[backups/.git] / scripts / restore-script.sh
index 5ae9fe792ea69a2732958bdb842d94ba241e5cee..daff5e571c414660f82e3e6d4da1c0e9de91cabd 100755 (executable)
@@ -1,28 +1,69 @@
 #!/bin/sh
 
-echo "Ran restore script with $@"
+function err() {
+  echo >&2 "-E- $1"
+  exit 1
+}
 
-exit 0
+[ -n "$3" ] && mountdir=$3
 
-export PATH=$rundir:/bin:/usr/bin
+[ -z "$mountdir" ] && err '$mountdir must be set'
+[ -z "$rundir"   ] && err '$rundir must be set'
 
-if [ $# != 1 ]; then
-  echo >&2 "Usage: $0 <source-directory> <target-directory>"
-  echo >&2 "Example: $0 / /"
-  exit 1
+export PATH=${rundir%%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
+
+if [ ! -z "$1" -o ! -d "$2" ]; then
+  err "
+Usage: $0 <source-dir> <relocate-dir> [<mnt-dir>]
+       source-dir   - directory on backup disks to restore from (relative to $mountdir)
+       relocate-dir - base directory to restore files to        (usually /)
+       mnt-dir      - directory where backup disk is mounted    (optional)
+
+  Examples:
+    % $0 / / /mnt/cdrom # Restore everything from disks (explicitly specifying dvd mount point.)
+    % $0 / /            # Restore everything from disks
+    % $0 /home /        # Restore only files under /home on disks to /home on the system
+    % $0 /home /home    # Restore files under /home on disks to /home/home on the system (probably not what you want.)
+"
 fi
 
-# Get the device with the CD in it here
-device=$(mount | grep "on $mountdir " | awk '{print$1}')
+device=$(mount | grep "on ${mountdir%%/} " | awk '{print$1}')
+
+[ -z "$device" ] && err "Cannot determine cdrom device"
+
+cp ${mountdir%%/}/backups.db ${mountdir%%/}/backup-status.txt $rundir
+dbfile=${rundir%%/}/backups.db
+
+dates=$(cat $dbfile | list-dates.sh)
+
+for date in $dates; do
+  filelist=$(tempfile)
+  # Check to see if files are actually needed from the current disk before requesting it.
+  cat $dbfile | files-from-date.sh $date | grep -z -Z -e "^${1%%/}/" > $filelist
+  if [ -s $filelist ]; then
+    success=false
+    while ! $success; do
+      eject $device
+      [ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
+      echo "Please insert backup disk:  $date"
+      echo "Press Enter to continue"
+      read bogus
+      eject -t $device
+
+      # Mount the media
+      mount -t ext2 $device ${mountdir%%/}
 
-cp $mountdir/backups.db $mountdir
+      if grep -q $date ${mountdir%%/}/backup-status.txt; then
+        success=true
+      else
+        echo "This doesn't seem to be the right disk."
+      fi
+    done
 
-for date in $(cat $dbfile | list-dates.sh); do
-  eject $device
-  echo >&2 "Please insert backup disk:  $date"
-  echo >&2 "Then press any key"
-  read bogus
-  # Mount the media
-  # rsync-cmd.sh won't work here in its current encarnation
-  cat $dbfile | files-from-date.sh | rsync-cmd.sh $1
+    rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
+    cat $filelist | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
+  else
+    echo "No files are needed from disk: $date.  Skipping it."
+  fi
+  rm -f $filelist
 done